"""non nullable fields

Revision ID: cc01c50edacd
Revises: 729a1c13fe30
Create Date: 2021-10-08 16:56:03.359471

"""
from typing import Optional

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision: str = "cc01c50edacd"
down_revision: Optional[str] = "729a1c13fe30"
branch_labels: Optional[str] = None
depends_on: Optional[str] = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column("mags_analysis", "binned_contig_num", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("mags_analysis", "input_contig_num", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column(
        "mags_analysis", "lowDepth_contig_num", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column(
        "mags_analysis", "too_short_contig_num", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column(
        "mags_analysis", "unbinned_contig_num", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column(
        "metagenome_assembly",
        "asm_score",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column("metagenome_assembly", "contig_bp", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "contigs", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "ctg_L50", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "ctg_L90", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "ctg_N50", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "ctg_N90", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column(
        "metagenome_assembly",
        "ctg_logsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column("metagenome_assembly", "ctg_max", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column(
        "metagenome_assembly",
        "ctg_powsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column(
        "metagenome_assembly",
        "gap_pct",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column(
        "metagenome_assembly",
        "gc_avg",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column(
        "metagenome_assembly",
        "gc_std",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column(
        "metagenome_assembly", "num_aligned_reads", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column(
        "metagenome_assembly", "num_input_reads", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column("metagenome_assembly", "scaf_L50", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_L90", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_N50", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_N90", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_bp", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_l_gt50k", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column(
        "metagenome_assembly",
        "scaf_logsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column("metagenome_assembly", "scaf_max", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column("metagenome_assembly", "scaf_n_gt50K", existing_type=sa.BIGINT(), nullable=True)
    op.alter_column(
        "metagenome_assembly", "scaf_pct_gt50K", existing_type=sa.BIGINT(), nullable=True
    )
    op.alter_column(
        "metagenome_assembly",
        "scaf_powsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=True,
    )
    op.alter_column("metagenome_assembly", "scaffolds", existing_type=sa.BIGINT(), nullable=True)
    op.add_column("principal_investigator", sa.Column("orcid", sa.String(), nullable=True))
    op.add_column(
        "study",
        sa.Column(
            "funding_sources",
            postgresql.JSONB(astext_type=sa.Text()),  # type: ignore
            nullable=True,
        ),
    )
    op.add_column(
        "study",
        sa.Column(
            "has_credit_associations",
            postgresql.JSONB(astext_type=sa.Text()),  # type: ignore
            nullable=True,
        ),
    )
    op.add_column(
        "study",
        sa.Column(
            "relevant_protocols",
            postgresql.JSONB(astext_type=sa.Text()),  # type: ignore
            nullable=True,
        ),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("study", "relevant_protocols")
    op.drop_column("study", "has_credit_associations")
    op.drop_column("study", "funding_sources")
    op.drop_column("principal_investigator", "orcid")
    op.alter_column("metagenome_assembly", "scaffolds", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column(
        "metagenome_assembly",
        "scaf_powsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "metagenome_assembly", "scaf_pct_gt50K", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column(
        "metagenome_assembly", "scaf_n_gt50K", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column("metagenome_assembly", "scaf_max", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column(
        "metagenome_assembly",
        "scaf_logsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "metagenome_assembly", "scaf_l_gt50k", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column("metagenome_assembly", "scaf_bp", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "scaf_N90", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "scaf_N50", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "scaf_L90", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "scaf_L50", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column(
        "metagenome_assembly", "num_input_reads", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column(
        "metagenome_assembly", "num_aligned_reads", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column(
        "metagenome_assembly",
        "gc_std",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "metagenome_assembly",
        "gc_avg",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "metagenome_assembly",
        "gap_pct",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "metagenome_assembly",
        "ctg_powsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column("metagenome_assembly", "ctg_max", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column(
        "metagenome_assembly",
        "ctg_logsum",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column("metagenome_assembly", "ctg_N90", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "ctg_N50", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "ctg_L90", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "ctg_L50", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "contigs", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("metagenome_assembly", "contig_bp", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column(
        "metagenome_assembly",
        "asm_score",
        existing_type=postgresql.DOUBLE_PRECISION(precision=53),
        nullable=False,
    )
    op.alter_column(
        "mags_analysis", "unbinned_contig_num", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column(
        "mags_analysis", "too_short_contig_num", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column(
        "mags_analysis", "lowDepth_contig_num", existing_type=sa.BIGINT(), nullable=False
    )
    op.alter_column("mags_analysis", "input_contig_num", existing_type=sa.BIGINT(), nullable=False)
    op.alter_column("mags_analysis", "binned_contig_num", existing_type=sa.BIGINT(), nullable=False)
    # ### end Alembic commands ###
